
!ABCIncludeFile

!Datafier class by Jeff Slarve
!Copyright  Jeff Slarve
!All Rights Reserved

!The Datafier Class is for creation of on-the-fly variables that are usable in a thread-safe manner and accessible globally


  OMIT('EndOfInclude',_JSDatafierPresent_)
_JSDatafierPresent_  EQUATE(1)


   INCLUDE('CWSYNCHM.INC'),ONCE

  Itemize,Pre(JSDF)
OK         Equate(0)
Notify     Equate
Exists     Equate
ReadOnly   Equate
  end

JSDF_DEFAULT_NAMESPACE  EQUATE('DEFAULT')

DataType:JSDFUnset      EQUATE(254)
DataType:JSDFExpression EQUATE(255)                           

DatafierQ_type          Queue,Type
Label                     CString(60)
Label_Sort                CString(60)
Var                       ANY
Picture                   CString(20)
DataType                  Byte
Address                   Long
ReadOnly                  Byte
Bindable                  Byte
                        end

DataFierNameSpaceQ_Type Queue,Type
NameSpace                 CString(60)
NameSpace_Sort            CString(60)
Q                         &DataFierQ_Type
                        end

DataFierClass           Class,Type,MODULE('JSDF.CLW'),LINK('JSDF.CLW', _ABCLinkMode_),DLL(_ABCDllMode_)
IsThreadSafe              Byte
OptionExplicit            Byte
IsBound                   Byte,PRIVATE
NameSpace                 &DatafierNameSpaceQ_type,PRIVATE
QLock                     &ICriticalSection,PRIVATE
BindData                  Procedure(<String pNameSpace>)
ClearValue                Procedure(String pLabel,<Short pDir>,<String pNameSpace>) !Allows for clearing high or low
Construct                 Procedure
CSRelease                 Procedure,PRIVATE
CSWait                    Procedure,PRIVATE
Declare                   Procedure(String pLabel,<String pNameSpace>,Byte pBindable=FALSE),Long
Destruct                  Procedure
DisposeValue              Procedure(String pLabel,Byte pNoLock=False,Byte pUseCurrent=False,<String pNameSpace>),Long,Proc
Fetch                     Procedure(String pLabel,Byte pUseCurrent=False),Long,PRIVATE
FetchNameSpace            Procedure(<String pNameSpace>,Byte pUseCurrent=FALSE),Long,PRIVATE,Proc
GetAddress                Procedure(String pLabel,<String pNameSpace>),Long
GetValue                  Procedure(String pLabel,Byte pFormatted=False,<String pNameSpace>),ANY
GetValueList              Procedure(*Queue pQ,Short pLabelColumn=1,Short pValueColumn=2,Short pSortLabelColumn=3,Byte pFormatted=False,<String pNameSpace>)
SetReadOnly               Procedure(String pLabel,<String pNameSpace>,Byte pReadOnly=TRUE)
SetValue                  Procedure(String pLabel,? pValue,<String pPicture>,Byte pDataType=0,Byte pDigits=0,Byte pPrecision=0,Byte pBindable=FALSE,<String pNameSpace>),Long,Proc
UnbindData                Procedure
                        end

  EndOfInclude
