  Program

!Copyright  2008 Jeff Slarve
!All Rights Reserved

!This is an example of how to wrap the Datafier class in a DLL.


   Include('jsdf.inc')

JSDF DataFierClass

   map
     JSDF:BindData        (<String pNameSpace>)
     JSDF:ClearValue      (String pLabel,<Short pDir>,<String pNameSpace>) !Allows for clearing high or low
     JSDF:Declare         (String pLabel,<String pNameSpace>,Byte pBindable=FALSE),Long
     JSDF:DisposeValue    (String pLabel,Byte pNoLock=False,Byte pUseCurrent=False,<String pNameSpace>),Long,Proc
     JSDF:GetAddress      (String pLabel,<String pNameSpace>),Long
     JSDF:GetValue        (String pLabel,Byte pFormatted=False,<String pNameSpace>),ANY
     JSDF:GetValueList    (*Queue pQ,Short pLabelColumn=1,Short pValueColumn=2,Short pSortLabelColumn=3,Byte pFormatted=False,<String pNameSpace>)
     JSDF:SetReadOnly     (String pLabel,<String pNameSpace>,Byte pReadOnly=TRUE)
     JSDF:SetValue        (String pLabel,? pValue,<String pPicture>,Byte pDataType=0,Byte pDigits=0,Byte pPrecision=0,Byte pBindable=FALSE,<String pNameSpace>),Long,Proc
     JSDF:UnbindData                
   end

  Code

JSDF:BindData                  Procedure(<String pNameSpace>)

  Code

  JSDF.BindData(pNameSpace)

JSDF:ClearValue                Procedure(String pLabel,<Short pDir>,<String pNameSpace>) !Allows for clearing high or low

  Code

  JSDF.ClearValue(pLabel,pDir,pNameSpace)

JSDF:Declare                   Procedure(String pLabel,<String pNameSpace>,Byte pBindable=FALSE)!,Long

  Code

  Return JSDF.Declare(pLabel,pNameSpace,pBindable)

JSDF:DisposeValue              Procedure(String pLabel,Byte pNoLock=False,Byte pUseCurrent=False,<String pNameSpace>)!,Long,Proc

  Code

  Return JSDF.DisposeValue(pLabel,pNoLock,pUseCurrent,pNameSpace)

JSDF:GetAddress                Procedure(String pLabel,<String pNameSpace>)!,Long

  Code

  Return JSDF.GetAddress(pLabel,pNameSpace)

JSDF:GetValue                  Procedure(String pLabel,Byte pFormatted=False,<String pNameSpace>)!,ANY

  Code

  Return JSDF.GetValue(pLabel,pFormatted,pNameSpace)

JSDF:GetValueList              Procedure(*Queue pQ,Short pLabelColumn=1,Short pValueColumn=2,Short pSortLabelColumn=3,Byte pFormatted=False,<String pNameSpace>)

  Code

  JSDF.GetValueList(pQ,pLabelColumn,pValueColumn,pSortLabelColumn,pFormatted,pNameSpace)

JSDF:SetReadOnly               Procedure(String pLabel,<String pNameSpace>,Byte pReadOnly=TRUE)

  Code

  JSDF.SetReadOnly(pLabel,pNameSpace,pReadOnly)

JSDF:SetValue                  Procedure(String pLabel,? pValue,<String pPicture>,Byte pDataType=0,Byte pDigits=0,Byte pPrecision=0,Byte pBindable=FALSE,<String pNameSpace>)!,Long,Proc

  Code

  Return JSDF.SetValue(pLabel,pValue,pPicture,pDataType,pDigits,pPrecision,pBindable,pNameSpace)

JSDF:UnbindData                Procedure

  Code

  JSDF.UnbindData