

   MEMBER('dftestapp.clw')                                 ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('DFTES001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE                                             ! Generated from procedure template - Frame

AppFrame             APPLICATION('The Datafier in action'),AT(,,505,318),FONT('MS Sans Serif',8,,FONT:regular),CENTER,ICON('WAFRAME.ICO'),STATUS(-1,80,120,45),SYSTEM,MAX,RESIZE,MASK,IMM
                       MENUBAR,USE(?Menubar)
                         MENU('&File'),USE(?FileMenu)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('Demos'),USE(?Browse)
                           ITEM('Binding'),USE(?DemosBinding)
                           ITEM('Grid Example'),USE(?BrowseGridExample)
                           ITEM('Setting/Getting Data over multiple threads (Open as many of these as you''d like)'),USE(?BrowseMDIChild)
                         END
                         MENU('&Window'),USE(?WindowMenu),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?HelpMenu)
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::Menubar ROUTINE                                      ! Code for menu items on ?Menubar
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu::Browse ROUTINE                                       ! Code for menu items on ?Browse
  CASE ACCEPTED()
  OF ?DemosBinding
    START(Binding, 25000)
  OF ?BrowseGridExample
    START(Grid, 25000)
  OF ?BrowseMDIChild
    START(GetterChild, 25000)
  END
Menu::WindowMenu ROUTINE                                   ! Code for menu items on ?WindowMenu
Menu::HelpMenu ROUTINE                                     ! Code for menu items on ?HelpMenu

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(AppFrame)                                      ! Open window
  
  COMPILE ('**CW7**',_CWVER_=7000)
      AppFrame{PROP:TabBarVisible}  = False
  !**CW7**
  Do DefineListboxStyle
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::Menubar                                     ! Process menu items on ?Menubar menu
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::Browse                                      ! Process menu items on ?Browse menu
      DO Menu::WindowMenu                                  ! Process menu items on ?WindowMenu menu
      DO Menu::HelpMenu                                    ! Process menu items on ?HelpMenu menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

GetterChild PROCEDURE                                      ! Generated from procedure template - Window

Ndx Long
LOC:DataString       STRING(5000)                          !
DisplayQ  Queue
Label       String(60)
Value       String(100)
Sort        String(60)
          end
Window               WINDOW('Data Getter'),AT(,,393,227),FONT('MS Sans Serif',8,,FONT:regular),CENTER,TIMER(10),SYSTEM,GRAY,DOUBLE,MDI
                       LIST,AT(5,2,381,207),USE(?List1),VSCROLL,FORMAT('68L(2)|M~Label~C(0)@s255@1020L(2)|M~Value~C(0)@s255@'),FROM(DisplayQ)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('GetterChild')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(Window)                                        ! Open window
  Start(SetterChild)
  Do DefineListboxStyle
  INIMgr.Fetch('GetterChild',Window)                       ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('GetterChild',Window)                    ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:Timer
       Free(DisplayQ)
       JSDF:GetValueList(DisplayQ,1,2,3,FALSE,'SetterGetter')
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

SetterChild PROCEDURE                                      ! Generated from procedure template - Window

Ndx Long
LOC:DataString       STRING(5000)                          !
Window               WINDOW('Data Setter'),AT(,,369,104),FONT('MS Sans Serif',8,,FONT:regular),CENTER,TIMER(10),SYSTEM,GRAY,DOUBLE,MDI
                       PROMPT('This window has a timer. When the timer tics, it re-calculates the data that get' &|
   's read by the "Data Getter" window. Open the "Data Getter" to view the changes.'),AT(10,9,319,31),USE(?Prompt1)
                       PROMPT('This window is to demonstrate that the Datafier can be used to manage data acros' &|
   's threads. '),AT(7,51,363,23),USE(?Prompt2)
                       PROMPT('You can open multiple copies of these windows, and they won''t step on each other' &|
   ', try as they might.'),AT(7,73,363,23),USE(?Prompt2:2)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SetterChild')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Prompt1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(Window)                                        ! Open window
  
  Do DefineListboxStyle
  INIMgr.Fetch('SetterChild',Window)                       ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('SetterChild',Window)                    ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:Timer
        Loop Ndx = 1 to 100
          JSDF:SetValue('yada' & ndx,Random(1,0FFFFFFFH),,,,,,'SetterGetter')
        end
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

Grid PROCEDURE                                             ! Generated from procedure template - Window

x  long
y  long
w  long
GridString CString(5000)
ColumnToTally        BYTE                                  !
Window               WINDOW('Grid'),AT(,,535,268),FONT('MS Sans Serif',8,,FONT:regular),CENTER,SYSTEM,GRAY,DOUBLE,MDI
                       PROMPT('This is a dynamically generated grid. The only data that was pre-declared was th' &|
   'at of the X and Y counters. Most of the slowness that you might see when opening' &|
   ' the window is the 400 entry controls that were created on the fly for this demo' &|
   'nstration..'),AT(442,12,88,86),USE(?Prompt1)
                       PROMPT('Enter a column that you wish to tally, then click "Tally"'),AT(442,101,88,25),USE(?Prompt3)
                       SPIN(@n3),AT(465,130,35,10),USE(ColumnToTally),RANGE(1,20),STEP(1)
                       BUTTON('Tally'),AT(446,143,71,17),USE(?TallyButton)
                       BUTTON('Copy Grid'),AT(446,161,71,17),USE(?Button3)
                       PROMPT('For fun, uncomment out the JSDF:SetValue(x & ''.'' & y,x * y,,Datatype:Byte) and c' &|
   'omment out the line above it. You can then see what happens when the value reach' &|
   'es the limits of a byte'),AT(22,241,387,25),USE(?Prompt2)
                       BUTTON('&Close'),AT(488,253,45,14),USE(?Close),STD(std:close)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

feq Long
  CODE
  GlobalErrors.SetProcedureName('Grid')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Prompt1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(Window)                                        ! Open window
  0{PROP:Hide} = TRUE
   Loop x = 1 to 20
      Loop y = 1 to 20
        JSDF:SetValue(Thread() & '.' & x & '.' & y,x * y,,)
        !JSDF:SetValue(Thread() & '.' & x & '.' & y,x * y,,Datatype:Byte)
        JSDF:SetValue(Thread() & '.' & 'FEQ.' & x & '.' & y,Create(0,Create:Entry))
        feq = JSDF:GetValue(Thread() & '.' & 'FEQ.' & x & '.' & y)
        feq{PROP:XPos} = x * 20
        feq{PROP:YPos} = y * 10
        feq{PROP:RightOffset} = 2
        feq{PROP:Width} = 21
        feq{PROP:Height} = 11
        feq{PROP:flat} = True
        feq{PROP:Skip} = True
        feq{PROP:ReadOnly} = True
        !feq{PROP:BackGround} = Color:Btnface
        feq{PROP:Right} = TRUE
        !feq{PROP:Boxed} = false
        Change(feq,JSDF:GetValue(Thread() & '.' & x & '.' & y,x * y))
        Unhide(feq)
      end
   end
  0{PROP:Hide} = FALSE
  Do DefineListboxStyle
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?TallyButton
      ThisWindow.Update
        W = 0
        Case ColumnToTally
        of 1 to 20
          Loop y = 1 to 20
            w += JSDF:GetValue(Thread() & '.' & ColumnToTally & '.' & y)
          end
          Message('The total for column ' & ColumnToTally & ' equals ' & w)
        else
          Message('Please use a number from 1 to 20')
        end
    OF ?Button3
      ThisWindow.Update
        Loop x = 1 to 20
          Loop y = 1 to 20
            If GridString
             GridString = GridString & JSDF:GetValue(Thread() & '.' & x & '.' & y) & '<9>'
            else
             GridString = JSDF:GetValue(Thread() & '.' & x & '.' & y) & '<9>'
            end
          end
          GridString = GridString & '<10>'
        end
        SetClipBoard(GridString)
        Message('The grid was copied to your Windows clipboard.||You can paste that into Microsoft Excel|')
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

Binding              PROCEDURE                             ! Declare Procedure
  CODE
  JSDF:SetValue('A',100,,DataType:Long,,,TRUE,)
  JSDF:SetValue('B',200,,DataType:Long,,,TRUE,)
  JSDF:SetValue('C',300,,DataType:Long,,,TRUE,)
  JSDF:SetValue('D',400,,DataType:Long,,,TRUE,)
  JSDF:SetValue('E',500,,DataType:Long,,,TRUE,)
  JSDF:BindData()
  Message('The value of A+B+C+D+E = ' & Evaluate('A+B+C+D+E') & '||'&|
          'The code used was as such:||' &|
          'JSDF:SetValue(''A'',100,,DataType:Long,,,TRUE,)|'&|
          'JSDF:SetValue(''B'',200,,DataType:Long,,,TRUE,)|'&|
          'JSDF:SetValue(''C'',300,,DataType:Long,,,TRUE,)|'&|
          'JSDF:SetValue(''D'',400,,DataType:Long,,,TRUE,)|'&|
          'JSDF:SetValue(''E'',500,,DataType:Long,,,TRUE,)|'&|
          'JSDF:BindData()|'&|
          'Message(''The value of A+B+C+D+E = '' & Evaluate(''A+B+C+D+E''))|'&|
          'JSDF:UnBindData'     )
  JSDF:UnBindData
